///////////////////////////////////////////////////////////////////////
//
// RandomAddin.java : Provide a Java interface to the Simple add-in.
//
///////////////////////////////////////////////////////////////////////
//
// Copyright  1997-99 by the IBM Corporation. All Rights Reserved.
//
// Author:          Angel L. Diaz     aldiaz@us.ibm.com
//
// IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR
// ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING OR MODIFYING
// THIS SOFTWARE OR ITS DERIVATIVES.
//
///////////////////////////////////////////////////////////////////////

import java.awt.*;
import java.applet.Applet;

import ibm.techexplorer.techexplorer;
import ibm.techexplorer.control.techexplorerControl;
import ibm.techexplorer.axtchexp.AxTchExpRaw;
import ibm.techexplorer.dom.*;
import org.w3c.dom.*;

public class MathematicaCommandLine extends java.applet.Applet {  
  private techexplorer techexplorer = null;

	public void setPlugin( techexplorer obj )
	{
		System.out.println( "setPlugin" );

		if ( obj instanceof techexplorer )
			techexplorer = obj;

		System.out.println( techexplorer );

		int nRval = techexplorer.addInInitialize( "application/x-mathlink-mat-tex" );
		switch( nRval ) 
		{
			case techexplorer.ADDIN_SUCCESS:
			System.out.println( "setPlugin: Loaded" );
			break;
			case techexplorer.ADDIN_ERROR_AVAILABLE:
			System.out.println( "setPlugin: add-in not available" );
			break;
			case techexplorer.ADDIN_ERROR_LOAD:
			System.out.println( "setPlugin: can not load add-in dll" );
			break;
			default:
			System.out.println( "setPlugin: Not Loaded" );
			break;
		}
	}

	public void setControl( AxTchExpRaw obj )
	{
		System.out.println( "setControl" );

		if ( obj instanceof AxTchExpRaw )
			techexplorer = new techexplorerControl( obj );

		System.out.println( techexplorer );

		int nRval = techexplorer.addInInitialize( "application/x-mathlink-mat-tex" );
		switch( nRval ) 
		{
			case techexplorer.ADDIN_SUCCESS:
			System.out.println( "setPlugin: Loaded" );
			break;
			case techexplorer.ADDIN_ERROR_AVAILABLE:
			System.out.println( "setPlugin: add-in not available" );
			break;
			case techexplorer.ADDIN_ERROR_LOAD:
			System.out.println( "setPlugin: can not load add-in dll" );
			break;
			default:
			System.out.println( "setPlugin: Not Loaded" );
			break;
		}
	}

	public void init() 
	{
		System.out.println( "MathematicaCommandLine: init" );
	}

	public void start() 
	{     
		System.out.println( "MathematicaCommandLine: start" );
	}

	public void stop() 
	{
		System.out.println( "MathematicaCommandLine: stop" );
	}

	private String normalizeString( String string )
	{
		StringBuffer stringBuffer = new StringBuffer();
		char[] stringArray = string.toCharArray();

		for( int i=0; i<string.length(); i++ )
		{
			if ( stringArray[i] == '\\' && i < string.length()+1 && stringArray[i+1] == '\\' )
				continue;
			else
				stringBuffer.append( stringArray[i] ); 	
		}

		return stringBuffer.toString();
	}

	public void evaluate( String value ) 
	{
		System.out.println( "MathematicaCommandLine: evaluate: " + value);
		
		String rValue = techexplorer.addInBlockingEvaluate( 
			"application/x-mathlink-mat-tex", value );

		if ( rValue != null )
		{
			System.out.println( "MathematicaCommandLine: evaluate: " + rValue );

			rValue = normalizeString( rValue );

			System.out.println( "MathematicaCommandLine: evaluate: normalized string :" + rValue );

    		// Append result
    		System.out.println( "MathematicaCommandLine: evaluate: Append result" );
    		 
    		Document pDocument = techexplorer.getDocumentNode();
			Node verticalList = pDocument.getFirstChild().getFirstChild();
			Node lastChild = verticalList.getLastChild();

			Node lineBreak =  pDocument.createElement( "line-break" );
			Node newNode = ((TEDocument)pDocument).createFromTexString( "$$" + rValue + "$$" );

			lastChild.appendChild( lineBreak );
			lastChild.appendChild( newNode );

			// Append a new command prompt
			System.out.println( "MathematicaCommandLine: evaluate: Append a new command prompt" );

			lineBreak =  pDocument.createElement( "line-break" );
			lastChild.appendChild( lineBreak );

			String prompt = "\\fbox{\\inputbox[\\hsize]{\\TheInput}{}}";
			newNode = ((TEDocument)pDocument).createFromTexString( prompt );
  			lastChild.appendChild( newNode );

			lineBreak =  pDocument.createElement( "line-break" );
			lastChild.appendChild( lineBreak );

			String submit = "\\docLink{javascript:window.parent.frames[0].submit" +
			                "( '\\TheInput' );}{\\buttonbox{Submit}}";
			newNode = ((TEDocument)pDocument).createFromTexString( submit );
  			lastChild.appendChild( newNode );

			((TEDocument)pDocument).recomposeAndRedraw();
		}
	}
}
