///////////////////////////////////////////////////////////////////////
//
// MathematicaAddin.java : Provide a Java interface to the Mathematica
//                         add-in.
//
///////////////////////////////////////////////////////////////////////
//
// Copyright  1997-2000 by the IBM Corporation. All Rights Reserved.
//
// Author:         Thomas N. K. Ling     lingt@us.ibm.com
//
// IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR
// ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING OR MODIFYING
// THIS SOFTWARE OR ITS DERIVATIVES.
//
///////////////////////////////////////////////////////////////////////

import java.awt.*;
import java.applet.Applet;

import ibm.techexplorer.techexplorer;
import ibm.techexplorer.control.techexplorerControl;
import ibm.techexplorer.axtchexp.AxTchExpRaw;

public class MathematicaAddin extends Applet
{
    /*
     * techexplorer
     */

    private techexplorer techexplorer = null;

    public void setPlugin( techexplorer obj )
    {
       if ( obj instanceof techexplorer )
           techexplorer = obj;
    }


    public void setControl( AxTchExpRaw obj )
    {
       if ( obj instanceof AxTchExpRaw )
           techexplorer = new techexplorerControl( obj );
    }


	public void init()
	{	
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(505,188);
		mimeChoice.addItem("application/x-mathlink-mat-tex");
		mimeChoice.addItem("application/x-mathlink-mat-mathml");
		mimeChoice.addItem("application/x-mathlink-mathml-mathml");		
		try {
			mimeChoice.select(0);
		}
		catch (IllegalArgumentException e) { }
		add(mimeChoice);
		mimeChoice.setBounds(264,36,228,25);
		evalBtn.setLabel("Evaluate");
		evalBtn.setEnabled(false);
		add(evalBtn);
		evalBtn.setBackground(java.awt.Color.lightGray);
		evalBtn.setBounds(12,144,73,28);
		commandLabel.setText("Enter your math expression here:");
		add(commandLabel);
		commandLabel.setBounds(12,12,204,24);
		mimeLabel.setText("MIME Type");
		add(mimeLabel);
		mimeLabel.setBounds(264,12,95,16);
		outType.setText("TeX");
		outType.setAlignment(java.awt.Label.CENTER);
		add(outType);
		outType.setBounds(348,96,110,24);
		inLabel.setText("Input Type:");
		add(inLabel);
		inLabel.setBounds(264,72,72,22);
		outlabel.setText("Output Type:");
		add(outlabel);
		outlabel.setBounds(264,96,72,22);
		inType.setText("Mathematica");
		inType.setAlignment(java.awt.Label.CENTER);
		add(inType);
		inType.setBounds(348,72,110,24);
		commandText.setEnabled(false);
		add(commandText);
		commandText.setBounds(12,36,228,84);
		offButton.setCheckboxGroup(Group1);
		offButton.setState(true);
		offButton.setLabel("Unload AddIn");
		add(offButton);
		offButton.setBounds(132,132,112,19);
		onButton.setCheckboxGroup(Group1);
		onButton.setLabel("Load AddIn");
		add(onButton);
		onButton.setBounds(132,156,117,21);
		AddinLabel.setText("AddIn Status:");
		add(AddinLabel);
		AddinLabel.setBounds(264,120,72,22);
		AddInStatus.setText("Not Loaded");
		AddInStatus.setAlignment(java.awt.Label.CENTER);
		add(AddInStatus);
		AddInStatus.setBounds(348,120,110,24);
		//}}
	
		//{{REGISTER_LISTENERS
		SymItem lSymItem = new SymItem();
		mimeChoice.addItemListener(lSymItem);
		offButton.addItemListener(lSymItem);
		onButton.addItemListener(lSymItem);
		SymAction lSymAction = new SymAction();
		evalBtn.addActionListener(lSymAction);
		//}}
	}

    public void start() {      
    }

    public void stop() {
    }
	
	public void destroy() {
	    // clean up non-java object
	    techexplorer.gc();
	}

	//{{DECLARE_CONTROLS
	java.awt.Choice        mimeChoice   = new java.awt.Choice();
	java.awt.Button        evalBtn      = new java.awt.Button();
	java.awt.Label         commandLabel = new java.awt.Label();
	java.awt.Label         mimeLabel    = new java.awt.Label();
	java.awt.Label         outType      = new java.awt.Label();
	java.awt.Label         inLabel      = new java.awt.Label();
	java.awt.Label         outlabel     = new java.awt.Label();
	java.awt.Label         inType       = new java.awt.Label();
	java.awt.TextArea      commandText  = new java.awt.TextArea();
	java.awt.Checkbox      offButton    = new java.awt.Checkbox();
	java.awt.CheckboxGroup Group1       = new java.awt.CheckboxGroup();
	java.awt.Checkbox      onButton     = new java.awt.Checkbox();
	java.awt.Label         AddinLabel   = new java.awt.Label();
	java.awt.Label         AddInStatus  = new java.awt.Label();
	//}}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == mimeChoice)
			{
				mimeChoice_ItemStateChanged(event);
			}
			else if (object == offButton)
			{
				offButton_ItemStateChanged(event);
        		commandText.setEnabled( false );
				evalBtn.setEnabled( false );
			}
			else if (object == onButton)
			{
				onButton_ItemStateChanged(event);
        		commandText.setEnabled( true );
				evalBtn.setEnabled( true );
			}
		}
	}

	void mimeChoice_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		switch(mimeChoice.getSelectedIndex())
		{
		    case 0:
		        inType.setText("Mathematica");		        
		        outType.setText("TeX");
		    break;
		    case 1:
		        inType.setText("Mathematica");		        
		        outType.setText("MathML");
		    break;
		    case 2:
		        inType.setText("MathML");		        
		        outType.setText("MathML");
		    break;
		}
 	}

	void offButton_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		if (offButton.getState())
		{
		    // Unload add-in
			techexplorer.addInShutdown( mimeChoice.getSelectedItem() );
		    AddInStatus.setText("Not Loaded");
		}			 
	}

	void onButton_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		if (onButton.getState())
		{
		    // Load Add-in
         	loadAddin( mimeChoice.getSelectedItem() );
		}			 
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == evalBtn)
				evalBtn_ActionPerformed(event);
		}
	}

	void evalBtn_ActionPerformed(java.awt.event.ActionEvent event)
	{
        AddInStatus.setText("Evaluating...");	    
	    String sOut = techexplorer.addInBlockingEvaluate( mimeChoice.getSelectedItem(), commandText.getText() );
		AddInStatus.setText("Evaluate Completed");


        if (mimeChoice.getSelectedIndex() == 0)
    	   techexplorer.reloadFromTeXString( sOut );
        else
    	   techexplorer.reloadFromMMLString( sOut );           
	}

    void loadAddin(String mimeType)
	{
	     // Load Add-in
         int nRval = techexplorer.addInInitialize( mimeType );
			
  	     switch( nRval ) {
	         case techexplorer.ADDIN_SUCCESS:
                 AddInStatus.setText("Loaded");
             break;
		     case techexplorer.ADDIN_ERROR_AVAILABLE:
	             AddInStatus.setText( "Not Available" );
		     break;
		     case techexplorer.ADDIN_ERROR_LOAD:
	             AddInStatus.setText( "Load Failed" );
		     break;
		     default:
	    	     AddInStatus.setText( "Not Loaded" );
		     break;
		 }
	}
}
