///////////////////////////////////////////////////////////////////////
//
// TEMessageListener: Display the techexplorer logo when a 
// techexplorer instance is clicked. 
//
///////////////////////////////////////////////////////////////////////
//
// Copyright  1996-98 by the IBM Corporation. All Rights Reserved.
//
// Author:          Angel L. Diaz     aldiaz@us.ibm.com
//                  Barry M. Trager   bmt@watson.ibm.com
//                  Robert S. Sutor   sutor@us.ibm.com
//
// IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR
// ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING OR MODIFYING
// THIS SOFTWARE OR ITS DERIVATIVES.
//
///////////////////////////////////////////////////////////////////////

import java.applet.Applet;
import java.awt.*;
import ibm.techexplorer.techexplorer;
import ibm.techexplorer.control.techexplorerControl;
import ibm.techexplorer.axtchexp.AxTchExpRaw;
import ibm.techexplorer.awt.AWTEvent;
import ibm.techexplorer.awt.event.MouseEvent;
import ibm.techexplorer.awt.event.MouseListener;

public class TEMessageListener extends Applet implements MouseListener {
    MouseListenerDialog        mouseListenerDialog = null;
	Image                      TEImage             = null;

    private techexplorer       techexplorerObj = null;

    public void setPlugin( techexplorer obj )
    {
        if ( obj instanceof techexplorer )
            techexplorerObj = obj;

		registerListener();
    }

    public void setControl( AxTchExpRaw obj )
    {
        if ( obj instanceof AxTchExpRaw )
            techexplorerObj = new techexplorerControl( obj );

		registerListener();
    }

    public void init() { 
    }

    public void registerListener() {
       // register with techexplorer
    
	   if ( techexplorerObj == null )
	      System.out.println("TEMessageListener: registerListener() techexplorer == null");
	   else 
	   {
	      techexplorerObj.disableEvents( AWTEvent.MOUSE_EVENT_MASK );
	      techexplorerObj.addMouseListener( (MouseListener)this );
	   }
    }

    public void stop() {
    }

   	public void destroy() {
	    // clean up non-java object
	    techexplorerObj.gc();
	}

    public void mouseClicked( MouseEvent e ) { }
    public void mouseEntered( MouseEvent e ) { }
    public void mouseExited( MouseEvent e )  { }
    public void mousePressed( MouseEvent e ) { }
    public void mouseReleased( MouseEvent e ) { 
        if (mouseListenerDialog == null) {    
			TEImage = getImage(this.getDocumentBase(), "Java/thb16p.gif" );
            mouseListenerDialog = new MouseListenerDialog( "Mouse Listener Dialog", TEImage, 550, 250, techexplorerObj );
        } 
		if ( mouseListenerDialog.isVisible() ) {
		   techexplorerObj.reloadFromTeXString("\\Large\\pagecolor{blue}\\color{white}Click for a message from techexplorer!");
		   mouseListenerDialog.hide();
		}
	    else {
		   techexplorerObj.reloadFromTeXString("\\Large\\pagecolor{blue}\\color{white}Click to hide.");
           mouseListenerDialog.show();
		}
    }
}

class MouseListenerDialog extends Frame {
   techexplorer       techexplorerObj = null;
   Image              TEImage = null;
   int                width, height;

   public MouseListenerDialog(String title, Image TEImage, int width, int height, techexplorer techexplorerObj) {
      super(title);
	  this.techexplorerObj = techexplorerObj;
	  this.TEImage = TEImage;
      this.width = width;
	  this.height = height;
	  this.resize( width, height );
   }
    public boolean handleEvent(Event event) {
        if (event.id == Event.WINDOW_DESTROY) {
		   techexplorerObj.reloadFromTeXString("\\Large\\pagecolor{blue}\\color{white}Click for a message from techexplorer!");
           hide();
        } 
        return super.handleEvent(event);
    }
	public void paint(Graphics g) {
		g.drawImage( TEImage, 0, 0, this);
	}
}
