///////////////////////////////////////////////////////////////////////
//
// BufferedCanvas: 
//
///////////////////////////////////////////////////////////////////////
//
// Copyright (c) 1998-99 by the IBM Corporation. All Rights Reserved.
//
// Author:          Barry M. Trager   bmt@watson.ibm.com
//                  Angel L. Diaz     aldiaz@us.ibm.com                  
//
// IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR
// ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING OR MODIFYING
// THIS SOFTWARE OR ITS DERIVATIVES.
//
///////////////////////////////////////////////////////////////////////

import java.awt.*;

public class BufferedCanvas extends Canvas
{
	transient Image offScreenBuffer;
	transient Graphics gr;

	public void update(Graphics g)
	{
		Dimension dims=size();

		if (offScreenBuffer==null || (! (offScreenBuffer.getWidth(this) == dims.width && offScreenBuffer.getHeight(this) == dims.height))) 
		{
			offScreenBuffer = createImage(dims.width, dims.height);
			if (gr != null) gr.dispose();
			gr = offScreenBuffer.getGraphics();
		}

		gr.clearRect(0, 0, dims.width, dims.height);
		paint(gr);
		g.drawImage(offScreenBuffer, 0, 0, this);
	}
}




