///////////////////////////////////////////////////////////////////////
//
// Line: 
//
///////////////////////////////////////////////////////////////////////
//
// Copyright (c) 1998-99 by the IBM Corporation. All Rights Reserved.
//
// Author:          Barry M. Trager   bmt@watson.ibm.com
//                  Angel L. Diaz     aldiaz@us.ibm.com                  
//
// IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR
// ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING OR MODIFYING
// THIS SOFTWARE OR ITS DERIVATIVES.
//
///////////////////////////////////////////////////////////////////////

import java.awt.*;
import java.io.*;

public class Line implements Serializable
{
	public Point start;
	public Point end;

	Line(Point start, Point end)
	{
		this.start = start;
		this.end = end;
	}

	Line(int x1, int y1, int x2, int y2)
	{
		start = new Point(x1, y1);
		end = new Point(x2, y2);
	}

	public void draw(Graphics g) 
	{
		g.drawLine(start.x, start.y, end.x, end.y);
	}

	public boolean equals(Object obj) 
	{
		if (! (obj instanceof Line)) 
			return false;

		Line ln = (Line)obj;

		if ((this.start.equals(ln.start) && this.end.equals(ln.end)) || (this.start.equals(ln.end) && this.end.equals(ln.start)))
			return true;
		else 
			return false;
	}
}

