///////////////////////////////////////////////////////////////////////
//
// Spring: 
//
///////////////////////////////////////////////////////////////////////
//
// Copyright (c) 1998-99 by the IBM Corporation. All Rights Reserved.
//
// Author:          Barry M. Trager   bmt@watson.ibm.com
//                  Angel L. Diaz     aldiaz@us.ibm.com                  
//
// IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR
// ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING OR MODIFYING
// THIS SOFTWARE OR ITS DERIVATIVES.
//
///////////////////////////////////////////////////////////////////////

import java.awt.*;

public class Spring extends CircuitEdge
{
     Spring(Point p1, Point p2, String lab)
     {
		super(p1, p2, lab);
		actionString = "Draw Spring";
     }

     public void draw(Graphics g)
     {
		try {
			Point p0 = getPoint(1,2);

			int hloops = 4;

			int scale = distance(start,end)/(2*hloops+1);

			drawLine(g, start, getPoint(p0, -scale*hloops, 0));

			for (int i = -hloops; i < hloops; i += 1) {
				Point	p10 = getPoint(p0, scale*i,    0);
				Point	p11 = getPoint(p0, scale*i+3, -5);
				Point	p12 = getPoint(p0, scale*i+7,  5);
				Point	p13 = getPoint(p0, scale*i+scale, 0);

				drawLine(g, p10, p11);
				drawLine(g, p11, p12);
				drawLine(g, p12, p13);
			}

			drawLine(g, getPoint(p0, scale*hloops, 0), end);

			drawLabel(g,10,-10);
		}
		catch (ArithmeticException e) {}
     }

}
