///////////////////////////////////////////////////////////////////////
//
// SpringMass: 
//
///////////////////////////////////////////////////////////////////////
//
// Copyright (c) 1998-99 by the IBM Corporation. All Rights Reserved.
//
// Author:          Barry M. Trager   bmt@watson.ibm.com
//                  Angel L. Diaz     aldiaz@us.ibm.com                  
//
// IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR
// ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING OR MODIFYING
// THIS SOFTWARE OR ITS DERIVATIVES.
//
///////////////////////////////////////////////////////////////////////

import java.applet.*;
import java.awt.*;
import java.util.*;

import ibm.techexplorer.techexplorer;
import ibm.techexplorer.control.techexplorerControl;
import ibm.techexplorer.axtchexp.AxTchExpRaw;

public class SpringMass extends Applet 
{
    private static final boolean debug = true;
    SpringCanvas canvas = null;
    private static Frame f = new Frame("SpringMass");

    public static void main(String[] args)
    { 
        SpringMass applet = new SpringMass();
        f.add("Center", applet);
        f.pack();
        f.resize(500,450);
        f.show();
        applet.start();
    }

    public void start()
    {    
        canvas.start(this);    
    }

    public void stop()
    {
        canvas.stop();
    }

    public SpringMass()
    {
        setLayout(new BorderLayout());
        canvas = new SpringCanvas();
        add("Center", canvas);
    }

    public void setPlugin( techexplorer obj )
    {
	    if (debug) System.out.println( "SpringsMass: setPlugin" );

        if ( obj instanceof techexplorer )
		     canvas.setPlugin( obj );             
    }

    public void setControl( AxTchExpRaw obj )
    {
	    if (debug) System.out.println( "SpringsMass: setControl" );

        if ( obj instanceof AxTchExpRaw )
            canvas.setControl( obj );
    }    

    public boolean handleEvent(Event event) 
    {
        if (event.id == Event.WINDOW_DESTROY && event.target == f) 
        {
             System.exit(0);
        }   

        return super.handleEvent(event);
  }
}
